<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head><meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>JavaCodeReverseInJobHandler xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../../../../../apidocs/org/eclipse/papyrus/designer/languages/java/reverse/ui/handlers/JavaCodeReverseInJobHandler.html">View Javadoc</a></div><pre>
<a class="jxr_linenumber" name="L1" href="#L1">1</a>   <em class="jxr_javadoccomment">/*****************************************************************************</em>
<a class="jxr_linenumber" name="L2" href="#L2">2</a>   <em class="jxr_javadoccomment"> * Copyright (c) 2016 Cedric Dumoulin and others.</em>
<a class="jxr_linenumber" name="L3" href="#L3">3</a>   <em class="jxr_javadoccomment"> * </em>
<a class="jxr_linenumber" name="L4" href="#L4">4</a>   <em class="jxr_javadoccomment"> * All rights reserved. This program and the accompanying materials</em>
<a class="jxr_linenumber" name="L5" href="#L5">5</a>   <em class="jxr_javadoccomment"> * are made available under the terms of the Eclipse Public License v1.0</em>
<a class="jxr_linenumber" name="L6" href="#L6">6</a>   <em class="jxr_javadoccomment"> * which accompanies this distribution, and is available at</em>
<a class="jxr_linenumber" name="L7" href="#L7">7</a>   <em class="jxr_javadoccomment"> * <a href="http://www.eclipse.org/legal/epl-v10.htm" target="alexandria_uri">http://www.eclipse.org/legal/epl-v10.htm</a>l</em>
<a class="jxr_linenumber" name="L8" href="#L8">8</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L9" href="#L9">9</a>   <em class="jxr_javadoccomment"> * Contributors:</em>
<a class="jxr_linenumber" name="L10" href="#L10">10</a>  <em class="jxr_javadoccomment"> *   cedric.dumoulin@univ-lille1.fr - Initial API and implementation</em>
<a class="jxr_linenumber" name="L11" href="#L11">11</a>  <em class="jxr_javadoccomment"> *   </em>
<a class="jxr_linenumber" name="L12" href="#L12">12</a>  <em class="jxr_javadoccomment"> *****************************************************************************/</em>
<a class="jxr_linenumber" name="L13" href="#L13">13</a>  
<a class="jxr_linenumber" name="L14" href="#L14">14</a>  <strong class="jxr_keyword">package</strong> org.eclipse.papyrus.designer.languages.java.reverse.ui.handlers;
<a class="jxr_linenumber" name="L15" href="#L15">15</a>  
<a class="jxr_linenumber" name="L16" href="#L16">16</a>  <strong class="jxr_keyword">import</strong> java.util.Arrays;
<a class="jxr_linenumber" name="L17" href="#L17">17</a>  <strong class="jxr_keyword">import</strong> java.util.List;
<a class="jxr_linenumber" name="L18" href="#L18">18</a>  
<a class="jxr_linenumber" name="L19" href="#L19">19</a>  <strong class="jxr_keyword">import</strong> org.eclipse.core.commands.ExecutionEvent;
<a class="jxr_linenumber" name="L20" href="#L20">20</a>  <strong class="jxr_keyword">import</strong> org.eclipse.core.commands.IHandler;
<a class="jxr_linenumber" name="L21" href="#L21">21</a>  <strong class="jxr_keyword">import</strong> org.eclipse.core.runtime.IProgressMonitor;
<a class="jxr_linenumber" name="L22" href="#L22">22</a>  <strong class="jxr_keyword">import</strong> org.eclipse.core.runtime.IStatus;
<a class="jxr_linenumber" name="L23" href="#L23">23</a>  <strong class="jxr_keyword">import</strong> org.eclipse.core.runtime.Status;
<a class="jxr_linenumber" name="L24" href="#L24">24</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.ecore.resource.Resource;
<a class="jxr_linenumber" name="L25" href="#L25">25</a>  <strong class="jxr_keyword">import</strong> org.eclipse.jface.dialogs.ErrorDialog;
<a class="jxr_linenumber" name="L26" href="#L26">26</a>  <strong class="jxr_keyword">import</strong> org.eclipse.jface.viewers.ISelection;
<a class="jxr_linenumber" name="L27" href="#L27">27</a>  <strong class="jxr_keyword">import</strong> org.eclipse.jface.viewers.ITreeSelection;
<a class="jxr_linenumber" name="L28" href="#L28">28</a>  <strong class="jxr_keyword">import</strong> org.eclipse.jface.window.Window;
<a class="jxr_linenumber" name="L29" href="#L29">29</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.java.reverse.ui.Messages;
<a class="jxr_linenumber" name="L30" href="#L30">30</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.java.reverse.ui.ProjectExplorerNodeWalkerWithIProgress;
<a class="jxr_linenumber" name="L31" href="#L31">31</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.java.reverse.ui.ReverseSelectedNodeVisitor;
<a class="jxr_linenumber" name="L32" href="#L32">32</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.java.reverse.ui.dialog.ReverseCodeDialog;
<a class="jxr_linenumber" name="L33" href="#L33">33</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.java.reverse.ui.exception.JavaReverseException;
<a class="jxr_linenumber" name="L34" href="#L34">34</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.java.reverse.ui.utils.QualifiedNamesFromIJavaElementCollector;
<a class="jxr_linenumber" name="L35" href="#L35">35</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.infra.core.Activator;
<a class="jxr_linenumber" name="L36" href="#L36">36</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.infra.core.resource.NotFoundException;
<a class="jxr_linenumber" name="L37" href="#L37">37</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.infra.core.services.ServiceException;
<a class="jxr_linenumber" name="L38" href="#L38">38</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.uml.tools.model.UmlModel;
<a class="jxr_linenumber" name="L39" href="#L39">39</a>  <strong class="jxr_keyword">import</strong> org.eclipse.swt.widgets.Shell;
<a class="jxr_linenumber" name="L40" href="#L40">40</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Model;
<a class="jxr_linenumber" name="L41" href="#L41">41</a>  
<a class="jxr_linenumber" name="L42" href="#L42">42</a>  
<a class="jxr_linenumber" name="L43" href="#L43">43</a>  <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L44" href="#L44">44</a>  <em class="jxr_javadoccomment"> * A {@link IHandler} to start Java Code reverse.</em>
<a class="jxr_linenumber" name="L45" href="#L45">45</a>  <em class="jxr_javadoccomment"> * The current selection is retrieved. For each selected element, try to reverse it to UML if it correspond to </em>
<a class="jxr_linenumber" name="L46" href="#L46">46</a>  <em class="jxr_javadoccomment"> * Java code.</em>
<a class="jxr_linenumber" name="L47" href="#L47">47</a>  <em class="jxr_javadoccomment"> *  </em>
<a class="jxr_linenumber" name="L48" href="#L48">48</a>  <em class="jxr_javadoccomment"> * @author cedric dumoulin</em>
<a class="jxr_linenumber" name="L49" href="#L49">49</a>  <em class="jxr_javadoccomment"> * </em>
<a class="jxr_linenumber" name="L50" href="#L50">50</a>  <em class="jxr_javadoccomment"> * @since 2.0</em>
<a class="jxr_linenumber" name="L51" href="#L51">51</a>  <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="L52" href="#L52">52</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../../../../org/eclipse/papyrus/designer/languages/java/reverse/ui/handlers/JavaCodeReverseInJobHandler.html">JavaCodeReverseInJobHandler</a> <strong class="jxr_keyword">extends</strong> <a href="../../../../../../../../../org/eclipse/papyrus/designer/languages/java/reverse/ui/handlers/AbstractExecuteInJobHandler.html">AbstractExecuteInJobHandler</a> <strong class="jxr_keyword">implements</strong> IHandler {
<a class="jxr_linenumber" name="L53" href="#L53">53</a>  
<a class="jxr_linenumber" name="L54" href="#L54">54</a>  	<strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">static</strong> String DefaultGenerationModeleName = <span class="jxr_string">""</span>;
<a class="jxr_linenumber" name="L55" href="#L55">55</a>  
<a class="jxr_linenumber" name="L56" href="#L56">56</a>  	<strong class="jxr_keyword">protected</strong> ReverseSelectedNodeVisitor.Parameters parameters;
<a class="jxr_linenumber" name="L57" href="#L57">57</a>  	
<a class="jxr_linenumber" name="L58" href="#L58">58</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L59" href="#L59">59</a>  <em class="jxr_javadoccomment">	 * The selection recorded before the Job was started.</em>
<a class="jxr_linenumber" name="L60" href="#L60">60</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L61" href="#L61">61</a>  	<strong class="jxr_keyword">private</strong> ITreeSelection recordedSelection;
<a class="jxr_linenumber" name="L62" href="#L62">62</a>  
<a class="jxr_linenumber" name="L63" href="#L63">63</a>  	<strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">int</strong> selectedParser = 0;
<a class="jxr_linenumber" name="L64" href="#L64">64</a>  
<a class="jxr_linenumber" name="L65" href="#L65">65</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L66" href="#L66">66</a>  <em class="jxr_javadoccomment">	 * @see org.eclipse.papyrus.designer.languages.java.reverse.ui.handlers.AbstractExecuteInJobHandler#getJobName()</em>
<a class="jxr_linenumber" name="L67" href="#L67">67</a>  <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L68" href="#L68">68</a>  <em class="jxr_javadoccomment">	 * @return</em>
<a class="jxr_linenumber" name="L69" href="#L69">69</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L70" href="#L70">70</a>  	@Override
<a class="jxr_linenumber" name="L71" href="#L71">71</a>  	String getJobName() {
<a class="jxr_linenumber" name="L72" href="#L72">72</a>  		<strong class="jxr_keyword">return</strong> <span class="jxr_string">"Reverse Java Code"</span>;
<a class="jxr_linenumber" name="L73" href="#L73">73</a>  	}
<a class="jxr_linenumber" name="L74" href="#L74">74</a>  
<a class="jxr_linenumber" name="L75" href="#L75">75</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L76" href="#L76">76</a>  <em class="jxr_javadoccomment">	 * @param event</em>
<a class="jxr_linenumber" name="L77" href="#L77">77</a>  <em class="jxr_javadoccomment">	 * @return True if the execution should continue, false if the execution should stop.</em>
<a class="jxr_linenumber" name="L78" href="#L78">78</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L79" href="#L79">79</a>  	@Override
<a class="jxr_linenumber" name="L80" href="#L80">80</a>  	<strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">boolean</strong> doPrepareExecute(ExecutionEvent event) {
<a class="jxr_linenumber" name="L81" href="#L81">81</a>  		UmlModel umlModel;
<a class="jxr_linenumber" name="L82" href="#L82">82</a>  		Model modelRoot;
<a class="jxr_linenumber" name="L83" href="#L83">83</a>  		
<a class="jxr_linenumber" name="L84" href="#L84">84</a>  		<strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="L85" href="#L85">85</a>  			umlModel = getUmlModel();
<a class="jxr_linenumber" name="L86" href="#L86">86</a>  			modelRoot = (Model)umlModel.lookupRoot();
<a class="jxr_linenumber" name="L87" href="#L87">87</a>  		} <strong class="jxr_keyword">catch</strong> (NotFoundException e) {
<a class="jxr_linenumber" name="L88" href="#L88">88</a>  			<em class="jxr_comment">// No uml resource available. User must open a model. We open an error dialog with an explicit message to advice user.</em>
<a class="jxr_linenumber" name="L89" href="#L89">89</a>  			Shell shell = getShell();
<a class="jxr_linenumber" name="L90" href="#L90">90</a>  			Status errorStatus = <strong class="jxr_keyword">new</strong> Status(IStatus.ERROR, Activator.PLUGIN_ID, Messages.ReverseCodeHandler_NoModelError_Title);
<a class="jxr_linenumber" name="L91" href="#L91">91</a>  			ErrorDialog.openError(shell, <span class="jxr_string">""</span>, Messages.ReverseCodeHandler_NoModelError_Message, errorStatus);
<a class="jxr_linenumber" name="L92" href="#L92">92</a>  			<em class="jxr_comment">// Stop the handler execution.</em>
<a class="jxr_linenumber" name="L93" href="#L93">93</a>  			<strong class="jxr_keyword">return</strong> false;
<a class="jxr_linenumber" name="L94" href="#L94">94</a>  		} <strong class="jxr_keyword">catch</strong> (ServiceException e) {
<a class="jxr_linenumber" name="L95" href="#L95">95</a>  			<em class="jxr_comment">// No uml resource available. User must open a model. We open an error dialog with an explicit message to advice user.</em>
<a class="jxr_linenumber" name="L96" href="#L96">96</a>  			Shell shell = getShell();
<a class="jxr_linenumber" name="L97" href="#L97">97</a>  			Status errorStatus = <strong class="jxr_keyword">new</strong> Status(IStatus.ERROR, Activator.PLUGIN_ID, Messages.ReverseCodeHandler_NoPapyrusEditor_Title);
<a class="jxr_linenumber" name="L98" href="#L98">98</a>  			ErrorDialog.openError(shell, <span class="jxr_string">""</span>, Messages.ReverseCodeHandler_NoPapyrusEditor_Message, errorStatus);
<a class="jxr_linenumber" name="L99" href="#L99">99</a>  
<a class="jxr_linenumber" name="L100" href="#L100">100</a> 			<em class="jxr_comment">// Stop the handler execution.</em>
<a class="jxr_linenumber" name="L101" href="#L101">101</a> 			<strong class="jxr_keyword">return</strong> false;
<a class="jxr_linenumber" name="L102" href="#L102">102</a> 		}
<a class="jxr_linenumber" name="L103" href="#L103">103</a> 		
<a class="jxr_linenumber" name="L104" href="#L104">104</a> 		<em class="jxr_comment">// Open the dialog</em>
<a class="jxr_linenumber" name="L105" href="#L105">105</a> 		String modelUid = getModelUid(umlModel.getResource());
<a class="jxr_linenumber" name="L106" href="#L106">106</a> 
<a class="jxr_linenumber" name="L107" href="#L107">107</a> 		<em class="jxr_comment">// Get reverse parameters from a dialog</em>
<a class="jxr_linenumber" name="L108" href="#L108">108</a> 		Shell shell = getShell();
<a class="jxr_linenumber" name="L109" href="#L109">109</a> 		<em class="jxr_comment">// ReverseCodeDialog dialog = new ReverseCodeDialog(shell, DefaultGenerationPackageName, Arrays.asList("generated") );</em>
<a class="jxr_linenumber" name="L110" href="#L110">110</a> 		<strong class="jxr_keyword">final</strong> <a href="../../../../../../../../../org/eclipse/papyrus/designer/languages/java/reverse/ui/dialog/ReverseCodeDialog.html">ReverseCodeDialog</a> dialog = getDialog(shell, modelUid);
<a class="jxr_linenumber" name="L111" href="#L111">111</a> 
<a class="jxr_linenumber" name="L112" href="#L112">112</a> 		<strong class="jxr_keyword">int</strong> res = dialog.open();
<a class="jxr_linenumber" name="L113" href="#L113">113</a> 		<em class="jxr_comment">// System.out.println("dialog result =" + res);</em>
<a class="jxr_linenumber" name="L114" href="#L114">114</a> 		<strong class="jxr_keyword">if</strong> (res == Window.CANCEL) {
<a class="jxr_linenumber" name="L115" href="#L115">115</a> 			<strong class="jxr_keyword">return</strong> false;
<a class="jxr_linenumber" name="L116" href="#L116">116</a> 		}
<a class="jxr_linenumber" name="L117" href="#L117">117</a> 		
<a class="jxr_linenumber" name="L118" href="#L118">118</a> 		parameters = <strong class="jxr_keyword">new</strong> ReverseSelectedNodeVisitor.Parameters();
<a class="jxr_linenumber" name="L119" href="#L119">119</a> 		parameters.setSearchPaths( Arrays.asList(dialog.getSearchPath() ) );
<a class="jxr_linenumber" name="L120" href="#L120">120</a> 		parameters.setUmlRootPackage( modelRoot);
<a class="jxr_linenumber" name="L121" href="#L121">121</a> 		parameters.setPackageName( getPackageName(dialog) );
<a class="jxr_linenumber" name="L122" href="#L122">122</a> 		selectedParser = dialog.getSelectedParserIndex();
<a class="jxr_linenumber" name="L123" href="#L123">123</a> 		parameters.setCreationPaths(dialog.getCreationPaths());
<a class="jxr_linenumber" name="L124" href="#L124">124</a> 		
<a class="jxr_linenumber" name="L125" href="#L125">125</a> 		<em class="jxr_comment">// Create reverse command</em>
<a class="jxr_linenumber" name="L126" href="#L126">126</a> 		ISelection selection = getCurrentSelection();
<a class="jxr_linenumber" name="L127" href="#L127">127</a> 		<strong class="jxr_keyword">if</strong>(! (selection instanceof ITreeSelection) ) {
<a class="jxr_linenumber" name="L128" href="#L128">128</a> 			Status errorStatus = <strong class="jxr_keyword">new</strong> Status(IStatus.ERROR, Activator.PLUGIN_ID, Messages.ReverseCodeHandler_WrongSelectionType_Title);
<a class="jxr_linenumber" name="L129" href="#L129">129</a> 			ErrorDialog.openError(shell, <span class="jxr_string">""</span>, Messages.ReverseCodeHandler_WrongSelectionType_Message, errorStatus);
<a class="jxr_linenumber" name="L130" href="#L130">130</a> 
<a class="jxr_linenumber" name="L131" href="#L131">131</a> 			<em class="jxr_comment">// Stop the handler execution.</em>
<a class="jxr_linenumber" name="L132" href="#L132">132</a> 			<strong class="jxr_keyword">return</strong> false;
<a class="jxr_linenumber" name="L133" href="#L133">133</a> 		}
<a class="jxr_linenumber" name="L134" href="#L134">134</a> 		recordedSelection = (ITreeSelection)selection;
<a class="jxr_linenumber" name="L135" href="#L135">135</a> 		
<a class="jxr_linenumber" name="L136" href="#L136">136</a> 		<em class="jxr_comment">// Get qualified names of CUs in projects</em>
<a class="jxr_linenumber" name="L137" href="#L137">137</a> 		QualifiedNamesFromIJavaElementCollector collector = <strong class="jxr_keyword">new</strong> <a href="../../../../../../../../../org/eclipse/papyrus/designer/languages/java/reverse/ui/utils/QualifiedNamesFromIJavaElementCollector.html">QualifiedNamesFromIJavaElementCollector</a>(false, <strong class="jxr_keyword">true</strong>, false);
<a class="jxr_linenumber" name="L138" href="#L138">138</a> 		List&lt;String&gt; qualifiedNamesInProjects = collector.getQualifiedNamesFromSelection(recordedSelection);
<a class="jxr_linenumber" name="L139" href="#L139">139</a> 		parameters.setQualifiedNamesInProjects(qualifiedNamesInProjects);
<a class="jxr_linenumber" name="L140" href="#L140">140</a> 		
<a class="jxr_linenumber" name="L141" href="#L141">141</a> 		<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L142" href="#L142">142</a> 	}
<a class="jxr_linenumber" name="L143" href="#L143">143</a> 
<a class="jxr_linenumber" name="L144" href="#L144">144</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L145" href="#L145">145</a> <em class="jxr_javadoccomment">	 * Method called from a Job, and in a Transactionnal command</em>
<a class="jxr_linenumber" name="L146" href="#L146">146</a> <em class="jxr_javadoccomment">	 * @param monitor</em>
<a class="jxr_linenumber" name="L147" href="#L147">147</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L148" href="#L148">148</a> 	@Override
<a class="jxr_linenumber" name="L149" href="#L149">149</a> 	<strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">void</strong> doExecuteTransactionInJob(IProgressMonitor monitor) {
<a class="jxr_linenumber" name="L150" href="#L150">150</a> 		System.err.println(<span class="jxr_string">"Transaction and job called !"</span>);
<a class="jxr_linenumber" name="L151" href="#L151">151</a> 
<a class="jxr_linenumber" name="L152" href="#L152">152</a> 		<strong class="jxr_keyword">switch</strong>( selectedParser  ) {
<a class="jxr_linenumber" name="L153" href="#L153">153</a> 		<strong class="jxr_keyword">case</strong> 0 :
<a class="jxr_linenumber" name="L154" href="#L154">154</a> 		<strong class="jxr_keyword">case</strong> 1 :
<a class="jxr_linenumber" name="L155" href="#L155">155</a> 			<em class="jxr_comment">// JAvaParser</em>
<a class="jxr_linenumber" name="L156" href="#L156">156</a> 			ReverseSelectedNodeVisitor visitor = <strong class="jxr_keyword">new</strong> <a href="../../../../../../../../../org/eclipse/papyrus/designer/languages/java/reverse/ui/ReverseSelectedNodeVisitor.html">ReverseSelectedNodeVisitor</a>(parameters);
<a class="jxr_linenumber" name="L157" href="#L157">157</a> <em class="jxr_comment">//			ProjectExplorerNodeWalker reverseWalker = new ProjectExplorerNodeWalker(visitor);</em>
<a class="jxr_linenumber" name="L158" href="#L158">158</a> 			ProjectExplorerNodeWalkerWithIProgress reverseWalker = <strong class="jxr_keyword">new</strong> <a href="../../../../../../../../../org/eclipse/papyrus/designer/languages/java/reverse/ui/ProjectExplorerNodeWalkerWithIProgress.html">ProjectExplorerNodeWalkerWithIProgress</a>(visitor);
<a class="jxr_linenumber" name="L159" href="#L159">159</a> 			reverseWalker.visit(recordedSelection.toList(), monitor);
<a class="jxr_linenumber" name="L160" href="#L160">160</a> 			<strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="L161" href="#L161">161</a> 			
<a class="jxr_linenumber" name="L162" href="#L162">162</a> 		<strong class="jxr_keyword">case</strong> 2 :
<a class="jxr_linenumber" name="L163" href="#L163">163</a> 			<em class="jxr_comment">// JDT Parser</em>
<a class="jxr_linenumber" name="L164" href="#L164">164</a> 			System.err.println(<span class="jxr_string">"Use JDT parser (todo)"</span>);
<a class="jxr_linenumber" name="L165" href="#L165">165</a> 			<strong class="jxr_keyword">return</strong>;
<a class="jxr_linenumber" name="L166" href="#L166">166</a> 		}
<a class="jxr_linenumber" name="L167" href="#L167">167</a> 		<em class="jxr_comment">// Perform reverse</em>
<a class="jxr_linenumber" name="L168" href="#L168">168</a> 
<a class="jxr_linenumber" name="L169" href="#L169">169</a> 	}
<a class="jxr_linenumber" name="L170" href="#L170">170</a> 
<a class="jxr_linenumber" name="L171" href="#L171">171</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L172" href="#L172">172</a> <em class="jxr_javadoccomment">	 * Find the modelUid name contained into umlResource taken in parameter</em>
<a class="jxr_linenumber" name="L173" href="#L173">173</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L174" href="#L174">174</a> <em class="jxr_javadoccomment">	 * @param umlResource</em>
<a class="jxr_linenumber" name="L175" href="#L175">175</a> <em class="jxr_javadoccomment">	 * @return the modelUid name</em>
<a class="jxr_linenumber" name="L176" href="#L176">176</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L177" href="#L177">177</a> 	<strong class="jxr_keyword">private</strong> String getModelUid(Resource umlResource) {
<a class="jxr_linenumber" name="L178" href="#L178">178</a> 		<em class="jxr_comment">// Try to compute a uid identifying the model. Used to store user settings.</em>
<a class="jxr_linenumber" name="L179" href="#L179">179</a> 		String modelUid = umlResource.getURI().toPlatformString(<strong class="jxr_keyword">true</strong>);
<a class="jxr_linenumber" name="L180" href="#L180">180</a> 		<strong class="jxr_keyword">if</strong> (modelUid == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L181" href="#L181">181</a> 			<em class="jxr_comment">// Can't compute relatif model uid. Use absolute one</em>
<a class="jxr_linenumber" name="L182" href="#L182">182</a> <em class="jxr_comment">//			System.err.println("Can't compute relatif model uid. Use absolute one");</em>
<a class="jxr_linenumber" name="L183" href="#L183">183</a> 			modelUid = umlResource.getURI().path();
<a class="jxr_linenumber" name="L184" href="#L184">184</a> 		}
<a class="jxr_linenumber" name="L185" href="#L185">185</a> 		<strong class="jxr_keyword">return</strong> modelUid;
<a class="jxr_linenumber" name="L186" href="#L186">186</a> 	}
<a class="jxr_linenumber" name="L187" href="#L187">187</a> 
<a class="jxr_linenumber" name="L188" href="#L188">188</a> 
<a class="jxr_linenumber" name="L189" href="#L189">189</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L190" href="#L190">190</a> <em class="jxr_javadoccomment">	 * The dialog used for user.</em>
<a class="jxr_linenumber" name="L191" href="#L191">191</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L192" href="#L192">192</a> <em class="jxr_javadoccomment">	 * @param shell</em>
<a class="jxr_linenumber" name="L193" href="#L193">193</a> <em class="jxr_javadoccomment">	 * @param modelUid</em>
<a class="jxr_linenumber" name="L194" href="#L194">194</a> <em class="jxr_javadoccomment">	 * @return the dialog to show to user</em>
<a class="jxr_linenumber" name="L195" href="#L195">195</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L196" href="#L196">196</a> 	<strong class="jxr_keyword">protected</strong> <a href="../../../../../../../../../org/eclipse/papyrus/designer/languages/java/reverse/ui/dialog/ReverseCodeDialog.html">ReverseCodeDialog</a> getDialog(Shell shell, String modelUid) {
<a class="jxr_linenumber" name="L197" href="#L197">197</a> 		
<a class="jxr_linenumber" name="L198" href="#L198">198</a> 		String selectedProjectName;
<a class="jxr_linenumber" name="L199" href="#L199">199</a> 		<strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="L200" href="#L200">200</a> 			selectedProjectName = getSelectedProjectName();
<a class="jxr_linenumber" name="L201" href="#L201">201</a> 		} <strong class="jxr_keyword">catch</strong> (JavaReverseException e) {
<a class="jxr_linenumber" name="L202" href="#L202">202</a> 			selectedProjectName = <span class="jxr_string">""</span>;
<a class="jxr_linenumber" name="L203" href="#L203">203</a> 		}
<a class="jxr_linenumber" name="L204" href="#L204">204</a> 		
<a class="jxr_linenumber" name="L205" href="#L205">205</a> 		<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">new</strong> <a href="../../../../../../../../../org/eclipse/papyrus/designer/languages/java/reverse/ui/dialog/ReverseCodeDialog.html">ReverseCodeDialog</a>(shell, modelUid, selectedProjectName, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="L206" href="#L206">206</a> 	}
<a class="jxr_linenumber" name="L207" href="#L207">207</a> 	
<a class="jxr_linenumber" name="L208" href="#L208">208</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L209" href="#L209">209</a> <em class="jxr_javadoccomment">	 * Find the name of the model provided by the dialog</em>
<a class="jxr_linenumber" name="L210" href="#L210">210</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L211" href="#L211">211</a> <em class="jxr_javadoccomment">	 * @param dialog</em>
<a class="jxr_linenumber" name="L212" href="#L212">212</a> <em class="jxr_javadoccomment">	 *            opened dialog to user</em>
<a class="jxr_linenumber" name="L213" href="#L213">213</a> <em class="jxr_javadoccomment">	 * @return the name of the model. If the user has changed this name, return the name provided by the user; return the default model name</em>
<a class="jxr_linenumber" name="L214" href="#L214">214</a> <em class="jxr_javadoccomment">	 *         otherwise.</em>
<a class="jxr_linenumber" name="L215" href="#L215">215</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L216" href="#L216">216</a> 	<strong class="jxr_keyword">protected</strong> String getPackageName(<a href="../../../../../../../../../org/eclipse/papyrus/designer/languages/java/reverse/ui/dialog/ReverseCodeDialog.html">ReverseCodeDialog</a> dialog) {
<a class="jxr_linenumber" name="L217" href="#L217">217</a> 		String generationPackageName = dialog.getValue();
<a class="jxr_linenumber" name="L218" href="#L218">218</a> 		<strong class="jxr_keyword">if</strong> (generationPackageName == <strong class="jxr_keyword">null</strong> || generationPackageName.length() == 0) {
<a class="jxr_linenumber" name="L219" href="#L219">219</a> 			generationPackageName = DefaultGenerationModeleName;
<a class="jxr_linenumber" name="L220" href="#L220">220</a> 		}
<a class="jxr_linenumber" name="L221" href="#L221">221</a> 		<strong class="jxr_keyword">return</strong> generationPackageName;
<a class="jxr_linenumber" name="L222" href="#L222">222</a> 	}
<a class="jxr_linenumber" name="L223" href="#L223">223</a> }
</pre>
<hr/>
<div id="footer">Copyright &#169; 2016&#x2013;2017 <a href="https://www.eclipse.org/">Eclipse foundation</a>. All rights reserved.</div>
</body>
</html>
